/*
*       This is the Raiden cipher source code.
*       This file includes the encoding and decoding routines
*
*       Developed by Javier Polimn and Julio Csar Hernndez
*       Updated by A.Myasnikov
*       Last update: 29th of Jan, 2009.
*
*       Web: www.darksoftware.narod.ru
*/


#include <string.h>;

void __export __stdcall
crypt (unsigned long *data, unsigned long *result, unsigned long *key)
{

  unsigned long b0 = data[0];
  unsigned long b1 = data[1];
  unsigned long i;
  unsigned long sk;
  unsigned long k[4];
  memmove (k, key, 16);


  for (i = 0; i < 32; i++)
    {
      sk = k[i % 4] = ((k[0] + k[1]) + ((k[2] + k[3]) ^ (k[0] << k[2])));
      b0 += ((sk + b1) << 9) ^ ((sk - b1) ^ ((sk + b1) >> 14));
      b1 += ((sk + b0) << 9) ^ ((sk - b0) ^ ((sk + b0) >> 14));
    }
  result[0] = b0;
  result[1] = b1;
}


void __export __stdcall
decrypt (unsigned long *data, unsigned long *result, unsigned long *key)
{
  unsigned long b0 = data[0];
  unsigned long b1 = data[1];
  unsigned long i;
  unsigned long k[4];
  unsigned long subkeys[32];
  memmove (k, key, 16);



  for (i = 0; i < 32; i++)
    {
      k[i % 4] = ((k[0] + k[1]) + ((k[2] + k[3]) ^ (k[0] << k[2])));
      subkeys[i] = k[i % 4];
    }
  for (i = 31; i != -1; i--)
    {

      b1 -=
	((subkeys[i] + b0) << 9) ^ ((subkeys[i] -
				     b0) ^ ((subkeys[i] + b0) >> 14));
      b0 -=
	((subkeys[i] + b1) << 9) ^ ((subkeys[i] -
				     b1) ^ ((subkeys[i] + b1) >> 14));
    }
  result[0] = b0;
  result[1] = b1;

}
